<template>
  <div class="main">
    <div class="main-title">{{ msg }}</div>
    <div class="user-count">
      <div class="count">{{ count }}</div>
      Users
    </div>
    <div class="wrapper">
      <div v-for="user in users" :key="user.id" class="card">
        <div class="body-card">
          <div class="title">Name</div>
          <div class="name">{{ user.name }}</div>
          <div class="wrapper-card">
            <div>
              <div class="title">Email</div>
              <div class="email">{{ user.email }}</div>
            </div>
            <div>
              <div class="title">Phone</div>
              <div class="phone">{{ user.phone }}</div>
            </div>
            <div>
              <div class="title">Website</div>
              <div class="website">{{ user.website }}</div>
            </div>
          </div>
        </div>
      </div>
    </div>
  </div>
</template>

<script>
import axios from "axios";
import { mapGetters } from "vuex";

export default {
  name: "Users",
  props: {
    msg: String,
  },
  computed: {
    ...mapGetters({
      users: "getData",
      count: "getCountData",
    }),
  },
  mounted() {
    axios
      .get("https://jsonplaceholder.typicode.com/users")
      .then((response) => {
        this.setData(response.data);
      })
      .catch((error) => {
        JSON.stringify(error);
      });
  },
  methods: {
    setData(data) {
      this.$store.dispatch("setDatas", data);
    },
  },
};
</script>

<!-- Add "scoped" attribute to limit CSS to this component only -->
<style scoped>
.main {
  background-color: #f5f7fa;
  padding: 20px;
}
.main-title {
  font-size: 30px;
  font-weight: bold;
}
.count {
  color: #83dd8b;
  font-weight: 800;
  margin-right: 10px;
}
.user-count {
  border-bottom: 1px solid #e1e1e7;
  color: #646464;
  display: flex;
}
.wrapper {
  display: grid;
  grid-gap: 1rem;
  grid-template-columns: repeat(2, 1fr);
}
.card {
  background-color: #ffffff;
  padding: 30px;
  margin-top: 20px;
}
.body-card {
  display: flex;
  flex-direction: column;
}
.title {
  color: #cccaca;
  font-weight: bold;
}
.name {
  font-weight: bold;
  font-size: 25px;
  color: #4e4e4e;
}
.wrapper-card {
  display: flex;
  flex-direction: row;
  justify-content: space-between;
  margin-top: 20px;
}
.email {
  font-weight: bold;
  font-size: 18px;
  color: #4e4e4e;
}
.phone {
  font-weight: bold;
  font-size: 18px;
  color: #4e4e4e;
}
.website {
  font-weight: bold;
  font-size: 18px;
  color: #83dd8b;
}
</style>
